import { AuthProvider } from './interfaces/provider.interface';
import { AuthConfig } from './interfaces/config.interface';
import { Storage } from '@bravobit/bb-foundation/storage';
import { AuthMapper } from './helpers/mapper.helper';
import { Api } from '@bravobit/bb-foundation/api';
import { Router } from '@angular/router';
export declare class Auth {
    private _storage;
    private _mapper;
    private _api?;
    private _router?;
    private _config?;
    private readonly _apiUserStorageKey;
    private readonly _apiTokenStorageKey;
    private readonly _apiRefreshTokenStorageKey;
    private _user$;
    constructor(_storage: Storage, _mapper: AuthMapper, _api?: Api, _router?: Router, _config?: AuthConfig);
    initialize(): () => Promise<void>;
    readonly isAuthenticated: boolean;
    readonly user: import("rxjs").Observable<any>;
    readonly accessToken: string;
    readonly refreshToken: string;
    readonly payload: import("./interfaces/token.interface").AuthToken;
    me<T = any>(): import("rxjs").Observable<T>;
    signIn<T = any>(provider: AuthProvider, as?: string[]): Promise<any>;
    signInWithEmail(email: string, password: string, as?: string[]): Promise<any>;
    register<T = any>(data: any): Promise<any>;
    logout(): void;
    refresh(): import("rxjs").Observable<any>;
    requestPassword(email: string): Promise<any>;
    resetPassword(token: string, newPassword: string): Promise<any>;
    guard(type: string): false | import("@angular/router").UrlTree;
    setTokens(token: string, refreshToken: string): void;
    setUser<T = any>(user: T): void;
    clear(): void;
}
