import { IsRequired, IsRequiredConstructor, CanDisable, CanDisableConstructor, IsReadonly, IsReadonlyConstructor, IsGrouped, IsGroupedConstructor, IsFocused, IsFocusedConstructor, HasError, HasErrorConstructor } from '@bravobit/bb-foundation';
import { OnInit, TemplateRef } from '@angular/core';
import { ElementsError } from '../elements.interfaces';
import { Observable, Subject } from 'rxjs';
declare class BbFormControlBase {
}
declare const BbFormControlMixinBase: IsRequiredConstructor & IsGroupedConstructor & IsFocusedConstructor & IsReadonlyConstructor & CanDisableConstructor & HasErrorConstructor & typeof BbFormControlBase;
export declare class BbFormControl extends BbFormControlMixinBase implements OnInit, IsRequired, IsFocused, IsReadonly, IsGrouped, CanDisable, HasError {
    private _errors;
    label: string | TemplateRef<any> | null;
    hint: string | TemplateRef<any> | null;
    customErrors: {
        [error: string]: string | {
            token: string;
            data?: any;
        };
    };
    arrow: boolean;
    hideErrors: any;
    private _hideErrors;
    labelId: string;
    errors: Subject<any>;
    error$: Observable<string | {
        token: string;
        data?: any;
    } | null>;
    constructor(_errors: ElementsError[]);
    ngOnInit(): void;
    getDefaultError(token: string): (data?: any) => string | {
        token: string;
        data?: any;
    };
}
export {};
