import { Injectable, ɵɵdefineInjectable } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function StorageAttributes() { }
if (false) {
    /** @type {?|undefined} */
    StorageAttributes.prototype.expires;
}
/**
 * @record
 */
function CookieStorageAttributes() { }
if (false) {
    /** @type {?|undefined} */
    CookieStorageAttributes.prototype.domain;
    /** @type {?|undefined} */
    CookieStorageAttributes.prototype.path;
    /** @type {?|undefined} */
    CookieStorageAttributes.prototype.secure;
    /** @type {?|undefined} */
    CookieStorageAttributes.prototype.sameSite;
}
/**
 * @record
 */
function PolyfillStorageAttributes() { }

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function StorageStrategy() { }
if (false) {
    /**
     * @template T
     * @param {?} token
     * @return {?}
     */
    StorageStrategy.prototype.get = function (token) { };
    /**
     * @template T
     * @param {?} token
     * @param {?} value
     * @param {?=} attributes
     * @return {?}
     */
    StorageStrategy.prototype.set = function (token, value, attributes) { };
    /**
     * @param {?} token
     * @param {?=} attributes
     * @return {?}
     */
    StorageStrategy.prototype.remove = function (token, attributes) { };
    /**
     * @param {?=} attributes
     * @return {?}
     */
    StorageStrategy.prototype.clear = function (attributes) { };
    /**
     * @return {?}
     */
    StorageStrategy.prototype.isSupported = function () { };
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class CookieStorage {
    constructor() {
        this.decode = (/**
         * @param {?} cookieString
         * @return {?}
         */
        (cookieString) => {
            /** @type {?} */
            const result = {};
            /** @type {?} */
            const cookies = cookieString ? cookieString.split('; ') : [];
            /** @type {?} */
            const rdecode = /(%[0-9A-Z]{2})+/g;
            for (let index = 0; index < cookies.length; index++) {
                /** @type {?} */
                const parts = cookies[index].split('=');
                /** @type {?} */
                let cookie = parts.slice(1).join('=');
                if (cookie.charAt(0) === '"') {
                    cookie = cookie.slice(1, -1);
                }
                try {
                    /** @type {?} */
                    const name = parts[0].replace(rdecode, decodeURIComponent);
                    /** @type {?} */
                    const value = cookie.replace(rdecode, decodeURIComponent);
                    result[name] = this.jsonParse(value);
                }
                catch (_a) {
                    // Ignore cookies with an invalid name/value encoding.
                }
            }
            return result;
        });
        this.jsonParse = (/**
         * @template T
         * @param {?} rawValue
         * @return {?}
         */
        (rawValue) => {
            // Try to parse the data.
            /** @type {?} */
            let parsedValue = undefined;
            // Only parse the value when it is not null.
            if (rawValue !== undefined) {
                try {
                    parsedValue = JSON.parse(rawValue);
                }
                catch (_a) {
                    // The string could not be parsed to JSON.
                }
            }
            // Return the parsed value.
            return parsedValue;
        });
        this.stringifyAttribute = (/**
         * @param {?} token
         * @param {?} value
         * @return {?}
         */
        (token, value) => {
            if (!value) {
                return '';
            }
            /** @type {?} */
            const stringified = `; ${token}`;
            // Boolean attributes should not have a value.
            if (value === true) {
                return stringified;
            }
            return stringified + `= ${value}`;
        });
    }
    /**
     * @template T
     * @param {?} token
     * @return {?}
     */
    get(token) {
        /** @type {?} */
        const values = this.all();
        return (/** @type {?} */ (values[token]));
    }
    /**
     * @template T
     * @param {?} token
     * @param {?} value
     * @param {?=} attributes
     * @return {?}
     */
    set(token, value, attributes) {
        document.cookie = this.encode(token, value, Object.assign({ path: '/' }, attributes));
    }
    /**
     * @param {?} token
     * @param {?=} attributes
     * @return {?}
     */
    remove(token, attributes) {
        this.set(token, '', Object.assign({}, attributes, { expires: -1 }));
    }
    /**
     * @param {?=} attributes
     * @return {?}
     */
    clear(attributes) {
        /** @type {?} */
        const items = this.all();
        Object.keys(items)
            .forEach((/**
         * @param {?} token
         * @return {?}
         */
        token => this.remove(token, attributes)));
    }
    /**
     * @return {?}
     */
    isSupported() {
        return (navigator && navigator.cookieEnabled) || false;
    }
    /**
     * @private
     * @return {?}
     */
    all() {
        return this.decode(document.cookie);
    }
    /**
     * @private
     * @param {?} token
     * @param {?} value
     * @param {?} attributes
     * @return {?}
     */
    encode(token, value, attributes) {
        // Encode the token.
        /** @type {?} */
        const encodedToken = encodeURIComponent(token)
            .replace(/%(23|24|26|2B|5E|60|7C)/g, decodeURIComponent)
            .replace(/\(/g, '%28').replace(/\)/g, '%29');
        /** @type {?} */
        const rawValue = JSON.stringify(value);
        // Encode the value.
        /** @type {?} */
        const encodedValue = encodeURIComponent(rawValue)
            .replace(/%(23|24|26|2B|3A|3C|3E|3D|2F|3F|40|5B|5D|5E|60|7B|7D|7C)/g, decodeURIComponent);
        // Return the completed encoded string.
        return [encodedToken, '=', encodedValue, this.stringifyCookie(attributes)].join('');
    }
    /**
     * @private
     * @param {?} attributes
     * @return {?}
     */
    stringifyCookie(attributes) {
        // Make sure the expires attribute is a date and not a number.
        if (typeof attributes.expires === 'number') {
            /** @type {?} */
            const expires = new Date();
            expires.setMilliseconds(expires.getMilliseconds() + attributes.expires * 864e+5);
            attributes.expires = expires;
        }
        // Stringify all attributes.
        return this.stringifyAttribute('Expires', attributes.expires ? attributes.expires.toUTCString() : '')
            + this.stringifyAttribute('Domain', attributes.domain)
            + this.stringifyAttribute('Path', attributes.path)
            + this.stringifyAttribute('Secure', attributes.secure)
            + this.stringifyAttribute('SameSite', attributes.sameSite);
    }
}
if (false) {
    /**
     * @type {?}
     * @private
     */
    CookieStorage.prototype.decode;
    /**
     * @type {?}
     * @private
     */
    CookieStorage.prototype.jsonParse;
    /**
     * @type {?}
     * @private
     */
    CookieStorage.prototype.stringifyAttribute;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PolyfillStorage {
    /**
     * @param {?} storage
     */
    constructor(storage) {
        this._isSupported = false;
        this.checkIfSupported = (/**
         * @return {?}
         */
        () => {
            if (typeof this._storage === 'undefined') {
                return false;
            }
            try {
                this._storage.setItem('feature_test', 'yes');
                if (this._storage.getItem('feature_test') !== 'yes') {
                    return false;
                }
                this._storage.removeItem('feature_test');
                return true;
            }
            catch (_a) {
                return false;
            }
        });
        // Save the type of storage.
        this._storage = storage;
        // Validate the storage was passed.
        if (!this._storage) {
            throw new Error('No polyfill storage was passed.');
        }
        // Check if the storage is supported.
        this._isSupported = this.checkIfSupported();
    }
    /**
     * @template T
     * @param {?} token
     * @return {?}
     */
    get(token) {
        // Validate that the storage is supported.
        if (!this._isSupported) {
            return;
        }
        // Retrieve the raw data from the storage.
        /** @type {?} */
        const rawData = this._storage.getItem(token);
        // Try to parse the data.
        /** @type {?} */
        let parsedData = undefined;
        // Only parse the data when it is not null.
        if (rawData !== null) {
            try {
                parsedData = JSON.parse(rawData);
            }
            catch (_a) {
                // We dont do anything with failed parsing.
            }
        }
        // Return the parsed data.
        return parsedData;
    }
    /**
     * @template T
     * @param {?} token
     * @param {?} value
     * @param {?=} attributes
     * @return {?}
     */
    set(token, value, attributes) {
        // Validate that the storage is supported.
        if (!this._isSupported) {
            return;
        }
        console.log('nice work');
        // Stringify the data.
        /** @type {?} */
        const rawData = JSON.stringify(value);
        // Set the raw data in the storage.
        this._storage.setItem(token, rawData);
    }
    /**
     * @param {?} token
     * @param {?=} attributes
     * @return {?}
     */
    remove(token, attributes) {
        // Validate that the storage is supported.
        if (!this._isSupported) {
            return;
        }
        // Remove the item in the storage.
        this._storage.removeItem(token);
    }
    /**
     * @param {?=} attributes
     * @return {?}
     */
    clear(attributes) {
        // Validate that the storage is supported.
        if (!this._isSupported) {
            return;
        }
        // Clear the storage.
        this._storage.clear();
    }
    /**
     * @return {?}
     */
    isSupported() {
        return this._isSupported;
    }
}
if (false) {
    /**
     * @type {?}
     * @private
     */
    PolyfillStorage.prototype._storage;
    /**
     * @type {?}
     * @private
     */
    PolyfillStorage.prototype._isSupported;
    /**
     * @type {?}
     * @private
     */
    PolyfillStorage.prototype.checkIfSupported;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MemoryStorage {
    constructor() {
        // State.
        this._storage = {};
    }
    /**
     * @template T
     * @param {?} token
     * @return {?}
     */
    get(token) {
        return this._storage[token];
    }
    /**
     * @template T
     * @param {?} token
     * @param {?} value
     * @param {?=} attributes
     * @return {?}
     */
    set(token, value, attributes) {
        this._storage[token] = value;
    }
    /**
     * @param {?} token
     * @param {?=} attributes
     * @return {?}
     */
    remove(token, attributes) {
        delete this._storage[token];
    }
    /**
     * @param {?=} attributes
     * @return {?}
     */
    clear(attributes) {
        this._storage = {};
    }
    /**
     * @return {?}
     */
    isSupported() {
        return true;
    }
}
if (false) {
    /**
     * @type {?}
     * @private
     */
    MemoryStorage.prototype._storage;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Storage {
    constructor() {
        // All available strategies (sorted best to last).
        this._strategies = {
            local: new PolyfillStorage(localStorage),
            cookie: new CookieStorage(),
            session: new PolyfillStorage(sessionStorage),
            memory: new MemoryStorage()
        };
        // Current selected storage strategy.
        this._current = null;
        this._current = this.findBestStorageStrategy();
    }
    /**
     * @return {?}
     */
    get local() {
        return this._strategies.local;
    }
    /**
     * @return {?}
     */
    get cookie() {
        return this._strategies.cookie;
    }
    /**
     * @return {?}
     */
    get session() {
        return this._strategies.session;
    }
    /**
     * @return {?}
     */
    get memory() {
        return this._strategies.memory;
    }
    /**
     * @template T
     * @param {?} token
     * @return {?}
     */
    get(token) {
        return this._current.get(token);
    }
    /**
     * @template T
     * @param {?} token
     * @param {?} value
     * @param {?=} attributes
     * @return {?}
     */
    set(token, value, attributes) {
        this._current.set(token, value, attributes);
    }
    /**
     * @param {?} token
     * @param {?=} attributes
     * @return {?}
     */
    remove(token, attributes) {
        this._current.remove(token, attributes);
    }
    /**
     * @param {?=} attributes
     * @return {?}
     */
    clear(attributes) {
        this._current.clear(attributes);
    }
    /**
     * @return {?}
     */
    isSupported() {
        return !!this._current;
    }
    /**
     * @private
     * @return {?}
     */
    findBestStorageStrategy() {
        /** @type {?} */
        const types = Object.keys(this._strategies);
        // Loop through all available strategies to find the best.
        for (let index = 0; index < types.length; index++) {
            /** @type {?} */
            const type = types[index];
            /** @type {?} */
            const strategy = this._strategies[type];
            if (strategy.isSupported()) {
                return strategy;
            }
        }
        // If no strategy was returned we emit an error.
        throw new Error('No storage strategy was available.');
    }
}
Storage.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
Storage.ctorParameters = () => [];
/** @nocollapse */ Storage.ngInjectableDef = ɵɵdefineInjectable({ factory: function Storage_Factory() { return new Storage(); }, token: Storage, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    Storage.prototype._strategies;
    /**
     * @type {?}
     * @private
     */
    Storage.prototype._current;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { CookieStorage, MemoryStorage, PolyfillStorage, Storage };
//# sourceMappingURL=bravobit-bb-foundation-storage.js.map
