import { InjectionToken, Injectable, Optional, Inject, Pipe, APP_INITIALIZER, LOCALE_ID, NgModule } from '@angular/core';
import { __awaiter, __generator, __assign, __read } from 'tslib';
import { Storage } from '@bravobit/bb-foundation/storage';
import { Languages } from '@bravobit/bb-foundation';
import { HttpClient, HttpClientModule } from '@angular/common/http';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
//
// The configuration that can be passed when
// the user initializes the localize module.
//
var  
//
// The configuration that can be passed when
// the user initializes the localize module.
//
LocalizeConfig = /** @class */ (function () {
    function LocalizeConfig() {
        this.dictionary = [];
    }
    return LocalizeConfig;
}());
if (false) {
    /** @type {?} */
    LocalizeConfig.prototype.dictionary;
    /** @type {?} */
    LocalizeConfig.prototype.substitutions;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
//
// These are the options that the user has
// when localizing the token.
//
/**
 * @record
 */
function LocalizeOptions() { }
if (false) {
    /** @type {?|undefined} */
    LocalizeOptions.prototype.optional;
    /** @type {?|undefined} */
    LocalizeOptions.prototype.data;
}
/**
 * @record
 */
function LocalizeOptionsData() { }
/**
 * @record
 */
function LocalizeParams() { }
if (false) {
    /** @type {?} */
    LocalizeParams.prototype.token;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function LocalizeFunction() { }
if (false) {
    /**
     * @return {?}
     */
    LocalizeFunction.prototype.keyword = function () { };
    /**
     * @param {?} value
     * @return {?}
     */
    LocalizeFunction.prototype.transform = function (value) { };
}
/**
 * @record
 */
function LocalizeFunctionMap() { }
//
// This is the injection token that will be injected
// into the service so that the all localize functions
// can retrieved and used.
//
/** @type {?} */
var LOCALIZE_FUNCTION = new InjectionToken('localize_function');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function LocalizeHandlerProtocol() { }
if (false) {
    /**
     * @param {?} params
     * @param {?} localize
     * @return {?}
     */
    LocalizeHandlerProtocol.prototype.handle = function (params, localize) { };
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function LocalizeDictionaryParams() { }
if (false) {
    /** @type {?} */
    LocalizeDictionaryParams.prototype.id;
    /** @type {?|undefined} */
    LocalizeDictionaryParams.prototype.data;
    /** @type {?|undefined} */
    LocalizeDictionaryParams.prototype.locale;
    /** @type {?|undefined} */
    LocalizeDictionaryParams.prototype.supportedLanguages;
}
//
// This is the injection token that will be injected
// into the service so that the all extra dictionaries
// can retrieved and used.
//
/** @type {?} */
var LOCALIZE_EXTRA_DICTIONARY = new InjectionToken('localize_extra_dictionary');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
//
// This function transform the value
// to a lowercase variant of the value.
//
var  
//
// This function transform the value
// to a lowercase variant of the value.
//
LocalizeLowercaseFunction = /** @class */ (function () {
    function LocalizeLowercaseFunction() {
    }
    /**
     * @return {?}
     */
    LocalizeLowercaseFunction.prototype.keyword = /**
     * @return {?}
     */
    function () {
        return 'lowercase';
    };
    /**
     * @param {?} value
     * @return {?}
     */
    LocalizeLowercaseFunction.prototype.transform = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        return (value || '').toLowerCase();
    };
    return LocalizeLowercaseFunction;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
//
// This function transform the value
// to a uppercase variant of the value.
//
var  
//
// This function transform the value
// to a uppercase variant of the value.
//
LocalizeUppercaseFunction = /** @class */ (function () {
    function LocalizeUppercaseFunction() {
    }
    /**
     * @return {?}
     */
    LocalizeUppercaseFunction.prototype.keyword = /**
     * @return {?}
     */
    function () {
        return 'uppercase';
    };
    /**
     * @param {?} value
     * @return {?}
     */
    LocalizeUppercaseFunction.prototype.transform = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        return (value || '').toUpperCase();
    };
    return LocalizeUppercaseFunction;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ɵ0 = {
    locale: 'en-US',
    data: {
        'form-control-errors': {
            'required': 'This field is required.',
            'pattern': 'Invalid format.',
            'email': 'The field does not match a valid email address.',
            'fullNumber': 'The field should be a full number.',
            'min': 'Minimum amount should be {{min}}.',
            'max': 'Maximum amount should be {{max}}.',
            'minlength': 'Expected a minimum of {{requiredLength}} characters but got {{actualLength}} characters.',
            'maxlength': 'Expected a maximum of {{requiredLength}} characters but got {{actualLength}} characters.'
        },
        'tables': {
            'search': 'Search...',
            'loading': 'Loading...',
            'empty': 'There is nothing to find here.',
            'page': 'page',
            'error_not_found': 'A not found error occurred while fetching data from the server.',
            'error_server': 'A server error occurred while fetching data from the server.',
            'error_unknown': 'A unknown error occurred while fetching data from the server.'
        }
    }
};
/** @type {?} */
var LOCALIZATION_EXTRA_ENGLISH = {
    provide: LOCALIZE_EXTRA_DICTIONARY,
    useValue: ɵ0,
    multi: true
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ɵ0$1 = {
    locale: 'nl-NL',
    data: {
        'form-control-errors': {
            'required': 'Dit veld is verplicht.',
            'pattern': 'Ongeldig formaat.',
            'email': 'Het veld komt niet overeen met een geldig e-mailadres.',
            'fullNumber': 'Het veld moet een volledig getal zijn.',
            'min': 'Minimum hoeveelheid moet {{min}} zijn.',
            'max': 'Maximum hoeveelheid moet {{max}} zijn.',
            'minlength': 'Verwachtte minimaal {{requiredLength}} tekens, maar kreeg {{actualLength}} tekens.',
            'maxlength': 'Verwachtte maximaal {{requiredLength}} tekens, maar kreeg {{actualLength}} tekens.'
        },
        'tables': {
            'search': 'Zoeken...',
            'loading': 'Aan het laden...',
            'empty': 'Er is hier niets te vinden.',
            'page': 'pagina',
            'error_not_found': 'Er is een niet-gevonden fout opgetreden tijdens het ophalen van gegevens van de server.',
            'error_server': 'Er is een serverfout opgetreden bij het ophalen van gegevens van de server.',
            'error_unknown': 'Er is een onbekende fout opgetreden bij het ophalen van gegevens van de server.',
        }
    }
};
/** @type {?} */
var LOCALIZATION_EXTRA_DUTCH = {
    provide: LOCALIZE_EXTRA_DICTIONARY,
    useValue: ɵ0$1,
    multi: true
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var LocalizeMissingHandler = /** @class */ (function () {
    function LocalizeMissingHandler() {
        this.log = (/**
         * @param {?} message
         * @return {?}
         */
        function (message) {
            console && console.warn && console.warn(message);
        });
    }
    /**
     * @param {?} params
     * @param {?} localize
     * @return {?}
     */
    LocalizeMissingHandler.prototype.handle = /**
     * @param {?} params
     * @param {?} localize
     * @return {?}
     */
    function (params, localize) {
        // Log to the console when the token was not found
        // if the user did not mark it as optional.
        if (!params.optional) {
            this.log("Localize: The token with name: \"" + params.token + "\" was not found.");
        }
        // Return the default token back.
        return params.token;
    };
    return LocalizeMissingHandler;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    LocalizeMissingHandler.prototype.log;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var LocalizeDictionary = /** @class */ (function () {
    function LocalizeDictionary(_a, http) {
        var id = _a.id, data = _a.data, locale = _a.locale, supportedLanguages = _a.supportedLanguages;
        // Dictionary data.
        this._data = {};
        this._url = null;
        this.recursiveSearchValue = (/**
         * @param {?} data
         * @param {?} value
         * @return {?}
         */
        function (data, value) {
            if (typeof data === 'undefined' || typeof data === 'string') {
                return undefined;
            }
            return data[value];
        });
        this._id = id;
        this._locale = locale || 'en-US';
        this._supportedLanguages = supportedLanguages || [];
        this._http = http;
        // Set the correct variable to the url or data.
        if (typeof data === 'string') {
            this._url = data;
        }
        else {
            this._data = data;
        }
    }
    Object.defineProperty(LocalizeDictionary.prototype, "id", {
        get: /**
         * @return {?}
         */
        function () {
            return this._id;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LocalizeDictionary.prototype, "locale", {
        get: /**
         * @return {?}
         */
        function () {
            return this._locale;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LocalizeDictionary.prototype, "supportedLanguages", {
        get: /**
         * @return {?}
         */
        function () {
            return this._supportedLanguages;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    LocalizeDictionary.prototype.load = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var result, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        // If the url was not set the data was already loaded
                        // return true because it was successful.
                        if (!this._url) {
                            return [2 /*return*/, true];
                        }
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        // Try to load the data via a HTTP request.
                        return [4 /*yield*/, this._http.get(this._url, { headers: { 'X-No-Authorization': 'yes' } })
                                .toPromise()];
                    case 2:
                        result = _b.sent();
                        // Set the data.
                        this._data = result || {};
                        this._url = null;
                        // Return true because it succeeded.
                        return [2 /*return*/, true];
                    case 3:
                        _a = _b.sent();
                        // Return false because it failed.
                        return [2 /*return*/, false];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} extraDictionary
     * @param {?=} mode
     * @return {?}
     */
    LocalizeDictionary.prototype.combine = /**
     * @param {?} extraDictionary
     * @param {?=} mode
     * @return {?}
     */
    function (extraDictionary, mode) {
        if (mode === void 0) { mode = 'prepend'; }
        // Validate that the locale matches.
        if (extraDictionary.locale !== this._locale) {
            return;
        }
        // Extract the extra data.
        /** @type {?} */
        var extraData = extraDictionary.data || {};
        // If the selected mode is prepend
        // add the data in front.
        if (mode === 'prepend') {
            this._data = __assign({}, extraData, this._data);
            return;
        }
        // If the selected mode is append
        // add the data in the back.
        this._data = __assign({}, this._data, extraData);
    };
    /**
     * @param {?} token
     * @return {?}
     */
    LocalizeDictionary.prototype.search = /**
     * @param {?} token
     * @return {?}
     */
    function (token) {
        // Check if the token is present in the
        // data, if so return it.
        if (this._data[token]) {
            return this._data[token];
        }
        // Values might be nested in objects this means we need
        // to split them on the dot and search them recursively
        // in the data.
        /** @type {?} */
        var value = (token || '')
            .split('.')
            .filter((/**
         * @param {?} value
         * @return {?}
         */
        function (value) { return !!value; }))
            .reduce(this.recursiveSearchValue, this._data);
        // Check if the value is a string
        // if this is true it can be returned.
        if (typeof value === 'string') {
            return value;
        }
        // This means the translation was incorrect.
        return null;
    };
    return LocalizeDictionary;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    LocalizeDictionary.prototype._id;
    /**
     * @type {?}
     * @private
     */
    LocalizeDictionary.prototype._locale;
    /**
     * @type {?}
     * @private
     */
    LocalizeDictionary.prototype._supportedLanguages;
    /**
     * @type {?}
     * @private
     */
    LocalizeDictionary.prototype._http;
    /**
     * @type {?}
     * @private
     */
    LocalizeDictionary.prototype._data;
    /**
     * @type {?}
     * @private
     */
    LocalizeDictionary.prototype._url;
    /**
     * @type {?}
     * @private
     */
    LocalizeDictionary.prototype.recursiveSearchValue;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var Localize = /** @class */ (function () {
    function Localize(_http, _storage, _languages, _config, _missingHandler, _functions, _extras) {
        var _this = this;
        this._http = _http;
        this._storage = _storage;
        this._languages = _languages;
        this._config = _config;
        this._missingHandler = _missingHandler;
        this._functions = _functions;
        this._extras = _extras;
        this._storageToken = 'bb-language-dictionary-id';
        this.convertToParams = (/**
         * @param {?} tokenOrParams
         * @return {?}
         */
        function (tokenOrParams) {
            if (typeof tokenOrParams !== 'string') {
                // Destruct the params from the object.
                var token = tokenOrParams.token, optional = tokenOrParams.optional, data = tokenOrParams.data;
                // Make sure all parameters are valid
                // by type safe adding them.
                return { token: token, optional: optional || false, data: data || {} };
            }
            // If the parameter is a string fill in the blanks.
            return { token: tokenOrParams, optional: false, data: {} };
        });
        this.getMatches = (/**
         * @param {?} value
         * @param {?} substitutions
         * @return {?}
         */
        function (value, substitutions) {
            // Get the matching substitutions.
            var start = substitutions.start, end = substitutions.end;
            // Compose a regex that will find the matches.
            /** @type {?} */
            var regex = new RegExp(start + "([^" + end + "]+)" + end, 'g');
            // Execute the regex to find matches.
            /** @type {?} */
            var match = regex.exec(value);
            /** @type {?} */
            var matches = [];
            while (match !== null) {
                // Push a new match.
                matches.push({
                    match: match[0],
                    token: match[1]
                });
                // Try to find more matches.
                match = regex.exec(value);
            }
            // Return the processed value.
            return matches.filter((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return !!item; }));
        });
        this.reload = (/**
         * @return {?}
         */
        function () {
            window && window.location && window.location.reload && window.location.reload();
        });
        // Check if at least one language was passed in the config.
        if (this._config.dictionary.length < 1) {
            throw new Error('Localize: one or more languages should be supplied.');
        }
        // Gather the dictionaries.
        this._dictionaries = this._config.dictionary.map((/**
         * @param {?} item
         * @return {?}
         */
        function (item) { return new LocalizeDictionary(item, _this._http); }));
        // Save the best matching current dictionary.
        this._currentDictionary = this.retrieveBestMatchingDictionary();
        // Gather all the localize functions.
        this._functionMiddleware = this._functions.reduce((/**
         * @param {?} previous
         * @param {?} current
         * @return {?}
         */
        function (previous, current) {
            previous[current.keyword()] = current;
            return previous;
        }), {});
    }
    Object.defineProperty(Localize.prototype, "dictionaries", {
        get: /**
         * @return {?}
         */
        function () {
            return this._dictionaries;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Localize.prototype, "current", {
        get: /**
         * @return {?}
         */
        function () {
            return this._currentDictionary;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Localize.prototype, "locale", {
        get: /**
         * @return {?}
         */
        function () {
            return this._currentDictionary.locale;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    Localize.prototype.initialize = /**
     * @return {?}
     */
    function () {
        var _this = this;
        return (/**
         * @return {?}
         */
        function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2 /*return*/, this.load(this._currentDictionary)];
        }); }); });
    };
    /**
     * @param {?} id
     * @param {?=} reload
     * @return {?}
     */
    Localize.prototype.change = /**
     * @param {?} id
     * @param {?=} reload
     * @return {?}
     */
    function (id, reload) {
        if (reload === void 0) { reload = true; }
        // Try to fetch the dictionary.
        /** @type {?} */
        var dictionary = this._dictionaries.find((/**
         * @param {?} item
         * @return {?}
         */
        function (item) { return item.id === id; }));
        // Validate the dictionary exists.
        if (!dictionary) {
            throw new Error("Localize: Could not find dictionary with id: \"" + id + "\"");
        }
        // Save the language in the storage.
        this._storage.set(this._storageToken, dictionary.id);
        // Just quit if we don't need to reload.
        if (!reload) {
            return;
        }
        // We need to reload the application for the translations.
        return this.reload();
    };
    /**
     * @param {?=} reload
     * @return {?}
     */
    Localize.prototype.clear = /**
     * @param {?=} reload
     * @return {?}
     */
    function (reload) {
        if (reload === void 0) { reload = true; }
        // Remove the language in the local storage.
        this._storage.remove(this._storageToken);
        // Just quit if we don't need to reload.
        if (!reload) {
            return;
        }
        // We need to reload the application for the translations.
        return this.reload();
    };
    /**
     * @param {?} tokenOrParams
     * @return {?}
     */
    Localize.prototype.translate = /**
     * @param {?} tokenOrParams
     * @return {?}
     */
    function (tokenOrParams) {
        // 1. Convert to the params.
        /** @type {?} */
        var params = this.convertToParams(tokenOrParams);
        // 2. Try to find the translation in the dictionary.
        /** @type {?} */
        var searchResult = this._currentDictionary.search(params.token);
        // 3. Verify the translation was found.
        if (!searchResult) {
            return this._missingHandler.handle(params, this);
        }
        // 4. Find references in the translation that need to be translated as well.
        /** @type {?} */
        var processResult = this.findReferencesInTranslation(searchResult);
        // 5. Parse the interpolation data.
        return this.parseInterpolationData(processResult, params.data);
    };
    /**
     * @private
     * @param {?} value
     * @param {?} data
     * @return {?}
     */
    Localize.prototype.parseInterpolationData = /**
     * @private
     * @param {?} value
     * @param {?} data
     * @return {?}
     */
    function (value, data) {
        var _this = this;
        // Get the interpolation substitutions.
        /** @type {?} */
        var substitutions = this.getSubstitutions('interpolation', ['{{', '}}']);
        // Get all matches in the value.
        /** @type {?} */
        var matches = this.getMatches(value, substitutions);
        // Replace all matches with the parsed value.
        return matches.reduce((/**
         * @param {?} previous
         * @param {?} current
         * @return {?}
         */
        function (previous, current) {
            // Try to parse the token.
            /** @type {?} */
            var interpolatedToken = _this.interpolateFunctionData(current.token, data);
            // Replace the match with the parsed token.
            return previous.replace(current.match, interpolatedToken);
        }), "" + value);
    };
    /**
     * @private
     * @param {?} value
     * @param {?} interpolationData
     * @return {?}
     */
    Localize.prototype.interpolateFunctionData = /**
     * @private
     * @param {?} value
     * @param {?} interpolationData
     * @return {?}
     */
    function (value, interpolationData) {
        var _this = this;
        // Get the token and the methods by splitting
        // on the pipe symbol.
        var _a = __read(value.split('|').map((/**
         * @param {?} item
         * @return {?}
         */
        function (item) { return item.trim(); }))), token = _a[0], methods = _a.slice(1);
        // Get the value for the token from
        // the interpolation data.
        /** @type {?} */
        var interpolationValue = interpolationData[token] || token;
        // Loop through all the middleware methods and try to
        // conform the string to the given parameters.
        return methods.reduce((/**
         * @param {?} string
         * @param {?} middlewareName
         * @return {?}
         */
        function (string, middlewareName) {
            // Try to retrieve the middleware from the collection.
            /** @type {?} */
            var middleware = _this._functionMiddleware[middlewareName];
            // If the middleware is missing return an error
            // so that the user knows it was not found.
            if (!middleware) {
                return string;
            }
            // Execute the middleware function with the string.
            return middleware.transform(string);
        }), "" + interpolationValue);
    };
    /**
     * @private
     * @param {?} value
     * @return {?}
     */
    Localize.prototype.findReferencesInTranslation = /**
     * @private
     * @param {?} value
     * @return {?}
     */
    function (value) {
        var _this = this;
        // Get the reference substitutions.
        /** @type {?} */
        var substitutions = this.getSubstitutions('references', ['#(', ')']);
        // Get all matches in the value.
        /** @type {?} */
        var matches = this.getMatches(value, substitutions);
        // Replace all matches with the translated value.
        return matches.reduce((/**
         * @param {?} previous
         * @param {?} current
         * @return {?}
         */
        function (previous, current) {
            // Try to translate the token.
            /** @type {?} */
            var translatedToken = _this.translate(current.token);
            // Replace the match with the translated token.
            return previous.replace(current.match, translatedToken);
        }), value);
    };
    /**
     * @private
     * @param {?} type
     * @param {?} defaultValue
     * @return {?}
     */
    Localize.prototype.getSubstitutions = /**
     * @private
     * @param {?} type
     * @param {?} defaultValue
     * @return {?}
     */
    function (type, defaultValue) {
        /** @type {?} */
        var substitutions = (this._config
            && this._config.substitutions
            && this._config.substitutions[type]);
        // Get the substitutions.
        /** @type {?} */
        var value = (!substitutions || substitutions.length !== 2)
            ? defaultValue
            : substitutions;
        // Escape both substitutions so that they
        // can be used.
        /** @type {?} */
        var escape = /[.*+?^${}()|[\]\\]/g;
        /** @type {?} */
        var start = value[0].replace(escape, '\\$&');
        /** @type {?} */
        var end = value[1].replace(escape, '\\$&');
        // Return the substitutions.
        return { start: start, end: end };
    };
    /**
     * @private
     * @return {?}
     */
    Localize.prototype.retrieveBestMatchingDictionary = /**
     * @private
     * @return {?}
     */
    function () {
        // Get the dictionary based on storage.
        /** @type {?} */
        var storageDictionary = this.getDictionaryFromStorage();
        // Get the dictionary based on the supported language.
        /** @type {?} */
        var browserDictionary = this.getBestBrowserMatchDictionary();
        // Get the dictionary based on the first index.
        /** @type {?} */
        var firstDictionary = this._dictionaries[0];
        // Return the best matching dictionary.
        return storageDictionary || browserDictionary || firstDictionary;
    };
    /**
     * @private
     * @return {?}
     */
    Localize.prototype.getDictionaryFromStorage = /**
     * @private
     * @return {?}
     */
    function () {
        // Get dictionary id from the storage..
        /** @type {?} */
        var dictionaryId = this._storage.get(this._storageToken);
        // Return the dictionary based on the storage dictionary id.
        return this._dictionaries.find((/**
         * @param {?} item
         * @return {?}
         */
        function (item) { return item.id === dictionaryId; }));
    };
    /**
     * @private
     * @return {?}
     */
    Localize.prototype.getBestBrowserMatchDictionary = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        // Loop through all browser languages and return the
        // best matching dictionary.
        return this._languages.all.map((/**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var code = _a.code, region = _a.region;
            /** @type {?} */
            var languageCode = [code, region].filter((/**
             * @param {?} data
             * @return {?}
             */
            function (data) { return !!data; })).join('-');
            return _this._dictionaries.find((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return item.supportedLanguages.includes(languageCode); }));
        })).filter((/**
         * @param {?} item
         * @return {?}
         */
        function (item) { return !!item; })).find((/**
         * @param {?} _
         * @param {?} index
         * @return {?}
         */
        function (_, index) { return index === 0; }));
    };
    /**
     * @private
     * @param {?} dictionary
     * @return {?}
     */
    Localize.prototype.load = /**
     * @private
     * @param {?} dictionary
     * @return {?}
     */
    function (dictionary) {
        return __awaiter(this, void 0, void 0, function () {
            var loaded;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        // Try to load the dictionary data.
                        return [4 /*yield*/, dictionary.load()];
                    case 1:
                        loaded = _a.sent();
                        // Verify the data was loaded.
                        if (!loaded) {
                            throw new Error("Localize: Could not correctly fetch the data from: \"" + dictionary.id + "\"");
                        }
                        // Combine the extra dictionary data.
                        (this._extras || []).forEach((/**
                         * @param {?} extraDictionary
                         * @return {?}
                         */
                        function (extraDictionary) { return dictionary.combine(extraDictionary); }));
                        // Return the dictionary.
                        return [2 /*return*/, dictionary];
                }
            });
        });
    };
    Localize.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    Localize.ctorParameters = function () { return [
        { type: HttpClient },
        { type: Storage },
        { type: Languages },
        { type: LocalizeConfig, decorators: [{ type: Optional }] },
        { type: LocalizeMissingHandler },
        { type: Array, decorators: [{ type: Optional }, { type: Inject, args: [LOCALIZE_FUNCTION,] }] },
        { type: Array, decorators: [{ type: Optional }, { type: Inject, args: [LOCALIZE_EXTRA_DICTIONARY,] }] }
    ]; };
    return Localize;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    Localize.prototype._dictionaries;
    /**
     * @type {?}
     * @private
     */
    Localize.prototype._currentDictionary;
    /**
     * @type {?}
     * @private
     */
    Localize.prototype._functionMiddleware;
    /**
     * @type {?}
     * @private
     */
    Localize.prototype._storageToken;
    /**
     * @type {?}
     * @private
     */
    Localize.prototype.convertToParams;
    /**
     * @type {?}
     * @private
     */
    Localize.prototype.getMatches;
    /**
     * @type {?}
     * @private
     */
    Localize.prototype.reload;
    /**
     * @type {?}
     * @private
     */
    Localize.prototype._http;
    /**
     * @type {?}
     * @private
     */
    Localize.prototype._storage;
    /**
     * @type {?}
     * @private
     */
    Localize.prototype._languages;
    /**
     * @type {?}
     * @private
     */
    Localize.prototype._config;
    /**
     * @type {?}
     * @private
     */
    Localize.prototype._missingHandler;
    /**
     * @type {?}
     * @private
     */
    Localize.prototype._functions;
    /**
     * @type {?}
     * @private
     */
    Localize.prototype._extras;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbLocalize = /** @class */ (function () {
    function BbLocalize(_localize) {
        this._localize = _localize;
    }
    /**
     * @param {?} tokenOrParams
     * @param {?=} args
     * @return {?}
     */
    BbLocalize.prototype.transform = /**
     * @param {?} tokenOrParams
     * @param {?=} args
     * @return {?}
     */
    function (tokenOrParams, args) {
        // Validate that the localize service
        // exists in the pipe.
        if (!this._localize) {
            return tokenOrParams;
        }
        // Combine the params with the options
        // to form the localize params.
        /** @type {?} */
        var params = this.combineParamsWithOptions(tokenOrParams, args);
        // Try to localize the value.
        return this._localize.translate(params);
    };
    /**
     * @private
     * @param {?} tokenOrParams
     * @param {?=} args
     * @return {?}
     */
    BbLocalize.prototype.combineParamsWithOptions = /**
     * @private
     * @param {?} tokenOrParams
     * @param {?=} args
     * @return {?}
     */
    function (tokenOrParams, args) {
        // Gather the extras.
        /** @type {?} */
        var extras = args || {};
        // Loop through all the keys to find the set options.
        /** @type {?} */
        var options = Object.keys(extras).reduce((/**
         * @param {?} previous
         * @param {?} current
         * @return {?}
         */
        function (previous, current) {
            if (typeof extras[current] === 'undefined') {
                return previous;
            }
            previous[current] = extras[current];
            return previous;
        }), {});
        // Convert the string token to a params object.
        /** @type {?} */
        var params = typeof tokenOrParams === 'string'
            ? { token: tokenOrParams, optional: false, data: {} }
            : tokenOrParams;
        // Return the combined params and options.
        return __assign({}, params, options);
    };
    BbLocalize.decorators = [
        { type: Pipe, args: [{
                    name: 'bbLocalize'
                },] }
    ];
    /** @nocollapse */
    BbLocalize.ctorParameters = function () { return [
        { type: Localize, decorators: [{ type: Optional }] }
    ]; };
    return BbLocalize;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    BbLocalize.prototype._localize;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var LocalizeModule = /** @class */ (function () {
    function LocalizeModule() {
    }
    /**
     * @param {?} config
     * @return {?}
     */
    LocalizeModule.forRoot = /**
     * @param {?} config
     * @return {?}
     */
    function (config) {
        return {
            ngModule: LocalizeModule,
            providers: [
                // Angular providers.
                { provide: APP_INITIALIZER, deps: [Localize], useFactory: initializeLocale, multi: true },
                { provide: LOCALE_ID, deps: [Localize], useFactory: getLocale },
                // Config provider.
                { provide: LocalizeConfig, useValue: config },
                // Function providers.
                { provide: LOCALIZE_FUNCTION, useClass: LocalizeLowercaseFunction, multi: true },
                { provide: LOCALIZE_FUNCTION, useClass: LocalizeUppercaseFunction, multi: true },
                // Handler providers.
                { provide: LocalizeMissingHandler, useClass: LocalizeMissingHandler },
                // Service providers.
                Localize
            ]
        };
    };
    LocalizeModule.decorators = [
        { type: NgModule, args: [{
                    imports: [HttpClientModule],
                    declarations: [BbLocalize],
                    exports: [BbLocalize]
                },] }
    ];
    return LocalizeModule;
}());
/**
 * @param {?} localize
 * @return {?}
 */
function initializeLocale(localize) {
    return localize.initialize();
}
/**
 * @param {?} localize
 * @return {?}
 */
function getLocale(localize) {
    return localize.locale;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { BbLocalize, LOCALIZATION_EXTRA_DUTCH, LOCALIZATION_EXTRA_ENGLISH, LOCALIZE_EXTRA_DICTIONARY, LOCALIZE_FUNCTION, Localize, LocalizeConfig, LocalizeLowercaseFunction, LocalizeMissingHandler, LocalizeModule, LocalizeUppercaseFunction, getLocale, initializeLocale };
//# sourceMappingURL=bravobit-bb-foundation-localize.js.map
