import { Injectable, Optional, Inject, PLATFORM_ID, ɵɵdefineInjectable, ɵɵinject } from '@angular/core';
import { isPlatformBrowser } from '@angular/common';
import { __awaiter, __generator, __extends, __spread } from 'tslib';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var hasV8BreakIterator = (typeof Intl !== 'undefined' && ((/** @type {?} */ (Intl))).v8BreakIterator);
var Platform = /** @class */ (function () {
    function Platform(_platformId) {
        this._platformId = _platformId;
    }
    Object.defineProperty(Platform.prototype, "isBrowser", {
        // Browser check.
        get: 
        // Browser check.
        /**
         * @return {?}
         */
        function () {
            return this._platformId
                ? isPlatformBrowser(this._platformId)
                : typeof document === 'object' && !!document;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Platform.prototype, "isTrident", {
        // Rendering engines.
        get: 
        // Rendering engines.
        /**
         * @return {?}
         */
        function () {
            return this.isBrowser && /(msie|trident)/i.test(navigator.userAgent);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Platform.prototype, "isBlink", {
        get: /**
         * @return {?}
         */
        function () {
            return this.isBrowser && (!!(((/** @type {?} */ (window))).chrome || hasV8BreakIterator) &&
                typeof CSS !== 'undefined' && !this.isEdge && !this.isTrident);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Platform.prototype, "isWebkit", {
        get: /**
         * @return {?}
         */
        function () {
            return this.isBrowser && /AppleWebKit/i.test(navigator.userAgent)
                && !this.isBlink && !this.isEdge && !this.isTrident;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Platform.prototype, "isChrome", {
        // Browsers.
        get: 
        // Browsers.
        /**
         * @return {?}
         */
        function () {
            return this.isBrowser && /Google Inc./.test(navigator.vendor);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Platform.prototype, "isEdge", {
        get: /**
         * @return {?}
         */
        function () {
            return this.isBrowser && /(edge)/i.test(navigator.userAgent);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Platform.prototype, "isFirefox", {
        get: /**
         * @return {?}
         */
        function () {
            return this.isBrowser && /(firefox|minefield)/i.test(navigator.userAgent);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Platform.prototype, "isSafari", {
        get: /**
         * @return {?}
         */
        function () {
            return this.isBrowser && /safari/i.test(navigator.userAgent) && this.isWebkit;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Platform.prototype, "isIos", {
        // Platforms.
        get: 
        // Platforms.
        /**
         * @return {?}
         */
        function () {
            return this.isBrowser && /iPad|iPhone|iPod/.test(navigator.userAgent) && !('MSStream' in window);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Platform.prototype, "isAndroid", {
        get: /**
         * @return {?}
         */
        function () {
            return this.isBrowser && /android/i.test(navigator.userAgent) && !this.isTrident;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Platform.prototype, "isDesktop", {
        get: /**
         * @return {?}
         */
        function () {
            return this.isBrowser && !(/(iPhone|iPod|iPad|Android|BlackBerry|IEMobile)/.test(navigator.userAgent));
        },
        enumerable: true,
        configurable: true
    });
    Platform.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    Platform.ctorParameters = function () { return [
        { type: Object, decorators: [{ type: Optional }, { type: Inject, args: [PLATFORM_ID,] }] }
    ]; };
    /** @nocollapse */ Platform.ngInjectableDef = ɵɵdefineInjectable({ factory: function Platform_Factory() { return new Platform(ɵɵinject(PLATFORM_ID, 8)); }, token: Platform, providedIn: "root" });
    return Platform;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    Platform.prototype._platformId;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ImageConverter = /** @class */ (function () {
    function ImageConverter(_platform) {
        this._platform = _platform;
        // Data.
        this._types = ['image/png', 'image/jpeg'];
        this.calculateOffsetAndDimensions = (/**
         * @param {?} image
         * @param {?} canvasWidth
         * @param {?} canvasHeight
         * @return {?}
         */
        function (image, canvasWidth, canvasHeight) {
            /** @type {?} */
            var originalWidth = image.width;
            /** @type {?} */
            var originalHeight = image.height;
            /** @type {?} */
            var widthRatio = canvasWidth / originalWidth;
            /** @type {?} */
            var heightRatio = canvasHeight / originalHeight;
            /** @type {?} */
            var width = 0;
            /** @type {?} */
            var height = 0;
            if (originalWidth > originalHeight) {
                height = originalHeight * heightRatio;
                width = (originalWidth / originalHeight) * height;
            }
            else {
                width = originalWidth * widthRatio;
                height = (originalHeight / originalWidth) * width;
            }
            /** @type {?} */
            var xOffset = 0;
            /** @type {?} */
            var yOffset = 0;
            if (canvasHeight === height) {
                xOffset = -((width - canvasWidth) / 2);
            }
            else if (canvasWidth === width) {
                yOffset = -((height - canvasHeight) / 2);
            }
            return { xOffset: xOffset, yOffset: yOffset, width: width, height: height };
        });
    }
    /**
     * @param {?} contents
     * @param {?=} options
     * @return {?}
     */
    ImageConverter.prototype.toDataUri = /**
     * @param {?} contents
     * @param {?=} options
     * @return {?}
     */
    function (contents, options) {
        if (options === void 0) { options = null; }
        return __awaiter(this, void 0, void 0, function () {
            var image, canvasWidth, canvasHeight, canvas, context, _a, width, height, xOffset, yOffset;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        // Check if the current platform is a browser.
                        if (!this._platform.isBrowser) {
                            return [2 /*return*/, null];
                        }
                        // Get the image.
                        return [4 /*yield*/, this.getImage(contents)];
                    case 1:
                        image = _b.sent();
                        // Get the canvas width and height.
                        canvasWidth = (options && options.width) || image.width;
                        canvasHeight = (options && options.height) || image.height;
                        // Get the canvas and context.
                        canvas = document.createElement('canvas');
                        context = canvas.getContext('2d');
                        canvas.width = canvasWidth;
                        canvas.height = canvasHeight;
                        // Check if dimensions where supplied, else create the image.
                        if (!options) {
                            // Draw the image.
                            context.drawImage(image, 0, 0);
                            // Convert the canvas to a data url.
                            return [2 /*return*/, canvas.toDataURL(this._types[0])];
                        }
                        // Get the dimensions and offsets.
                        _a = this.calculateOffsetAndDimensions(image, canvasWidth, canvasHeight), width = _a.width, height = _a.height, xOffset = _a.xOffset, yOffset = _a.yOffset;
                        // Draw the image.
                        context.drawImage(image, 0, 0, image.width, image.height, xOffset, yOffset, width, height);
                        // Convert the canvas to a data url.
                        return [2 /*return*/, canvas.toDataURL(this._types[0])];
                }
            });
        });
    };
    /**
     * @private
     * @param {?} contents
     * @return {?}
     */
    ImageConverter.prototype.getImage = /**
     * @private
     * @param {?} contents
     * @return {?}
     */
    function (contents) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                // If the contents is already an HTML image element just return it.
                if (contents instanceof HTMLImageElement) {
                    return [2 /*return*/, contents];
                }
                // If the contents is a file convert it to an HTML image element.
                if (contents instanceof File) {
                    return [2 /*return*/, this.fileToImage(contents)];
                }
                // If the contents is a string convert it to an HTML image element.
                if (typeof contents === 'string') {
                    return [2 /*return*/, this.stringToImage(contents)];
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * @private
     * @param {?} file
     * @return {?}
     */
    ImageConverter.prototype.fileToImage = /**
     * @private
     * @param {?} file
     * @return {?}
     */
    function (file) {
        var _this = this;
        return new Promise((/**
         * @param {?} resolve
         * @param {?} reject
         * @return {?}
         */
        function (resolve, reject) {
            // Check if the file matches an image.
            if (!_this._types.includes(file.type)) {
                return reject('The selected file does not meet the required format.');
            }
            /** @type {?} */
            var fileReader = new FileReader();
            fileReader.readAsDataURL(file);
            fileReader.onloadend = (/**
             * @param {?} data
             * @return {?}
             */
            function (data) { return __awaiter(_this, void 0, void 0, function () {
                var dataUri, image;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            // Get the data URI.
                            dataUri = data.target['result'];
                            // Convert the data URI to a image element.
                            return [4 /*yield*/, this.stringToImage(dataUri)];
                        case 1:
                            image = _a.sent();
                            // Resolve the image.
                            return [2 /*return*/, resolve(image)];
                    }
                });
            }); });
            fileReader.onerror = (/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return reject(error); });
        }));
    };
    /**
     * @private
     * @param {?} src
     * @return {?}
     */
    ImageConverter.prototype.stringToImage = /**
     * @private
     * @param {?} src
     * @return {?}
     */
    function (src) {
        return new Promise((/**
         * @param {?} resolve
         * @param {?} reject
         * @return {?}
         */
        function (resolve, reject) {
            /** @type {?} */
            var image = new Image();
            image.src = src;
            image.onload = (/**
             * @return {?}
             */
            function () { return resolve(image); });
            image.onerror = (/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return reject(error); });
        }));
    };
    ImageConverter.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    ImageConverter.ctorParameters = function () { return [
        { type: Platform }
    ]; };
    /** @nocollapse */ ImageConverter.ngInjectableDef = ɵɵdefineInjectable({ factory: function ImageConverter_Factory() { return new ImageConverter(ɵɵinject(Platform)); }, token: ImageConverter, providedIn: "root" });
    return ImageConverter;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    ImageConverter.prototype._types;
    /**
     * @type {?}
     * @private
     */
    ImageConverter.prototype.calculateOffsetAndDimensions;
    /**
     * @type {?}
     * @private
     */
    ImageConverter.prototype._platform;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var Languages = /** @class */ (function () {
    function Languages() {
        this.getLanguages = (/**
         * @return {?}
         */
        function () {
            if (typeof navigator !== 'object') {
                return null;
            }
            /** @type {?} */
            var t = 'anguage';
            /** @type {?} */
            var n = navigator;
            /** @type {?} */
            var f = n['l' + t + 's'];
            /** @type {?} */
            var data = f && f.length ? f : (t = n['l' + t] ||
                n['browserL' + t] ||
                n['userL' + t]) ? [t] : t;
            return typeof data === 'string'
                ? data
                : data.join(';');
        });
    }
    Object.defineProperty(Languages.prototype, "all", {
        get: /**
         * @return {?}
         */
        function () {
            // Get the languages.
            /** @type {?} */
            var data = this.getLanguages();
            // Parse all languages by using a regex.
            /** @type {?} */
            var strings = (data || '')
                .match(/((([a-zA-Z]+(-[a-zA-Z0-9]+){0,2})|\*)(;q=[0-1](\.[0-9]+)?)?)*/g);
            // Get the content by parsing the strings.
            /** @type {?} */
            var content = strings.map((/**
             * @param {?} item
             * @return {?}
             */
            function (item) {
                if (!item) {
                    return null;
                }
                /** @type {?} */
                var bits = item.split(';');
                /** @type {?} */
                var ietf = bits[0].split('-');
                /** @type {?} */
                var hasScript = ietf.length === 3;
                return {
                    code: ietf[0],
                    script: hasScript ? ietf[1] : null,
                    region: hasScript ? ietf[2] : ietf[1],
                    quality: bits[1] ? parseFloat(bits[1].split('=')[1]) : 1.0
                };
            }));
            // Filter out all the empty items
            // and sort them by the quality.
            return content
                .filter((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return !!item; }))
                .sort((/**
             * @param {?} a
             * @param {?} b
             * @return {?}
             */
            function (a, b) { return b.quality - a.quality; }));
        },
        enumerable: true,
        configurable: true
    });
    Languages.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */ Languages.ngInjectableDef = ɵɵdefineInjectable({ factory: function Languages_Factory() { return new Languages(); }, token: Languages, providedIn: "root" });
    return Languages;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    Languages.prototype.getLanguages;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} value
 * @return {?}
 */
function coerceBooleanProperty(value) {
    return value != null && "" + value !== 'false';
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function CanDisable() { }
if (false) {
    /** @type {?} */
    CanDisable.prototype.disabled;
}
/**
 * @template T
 * @param {?} base
 * @return {?}
 */
function mixinDisabled(base) {
    return /** @class */ (function (_super) {
        __extends(class_1, _super);
        function class_1() {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var _this = _super.apply(this, __spread(args)) || this;
            _this._disable = false;
            return _this;
        }
        Object.defineProperty(class_1.prototype, "disabled", {
            get: /**
             * @return {?}
             */
            function () {
                return this._disable;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._disable = coerceBooleanProperty(value);
            },
            enumerable: true,
            configurable: true
        });
        return class_1;
    }(base));
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function CanLoad() { }
if (false) {
    /** @type {?} */
    CanLoad.prototype.loading;
}
/**
 * @template T
 * @param {?} base
 * @return {?}
 */
function mixinLoad(base) {
    return /** @class */ (function (_super) {
        __extends(class_1, _super);
        function class_1() {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var _this = _super.apply(this, __spread(args)) || this;
            _this._loading = false;
            return _this;
        }
        Object.defineProperty(class_1.prototype, "loading", {
            get: /**
             * @return {?}
             */
            function () {
                return this._loading;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._loading = coerceBooleanProperty(value);
            },
            enumerable: true,
            configurable: true
        });
        return class_1;
    }(base));
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function HasError() { }
if (false) {
    /** @type {?} */
    HasError.prototype.error;
}
/**
 * @template T
 * @param {?} base
 * @return {?}
 */
function mixinError(base) {
    return /** @class */ (function (_super) {
        __extends(class_1, _super);
        function class_1() {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var _this = _super.apply(this, __spread(args)) || this;
            _this._error = false;
            return _this;
        }
        Object.defineProperty(class_1.prototype, "error", {
            get: /**
             * @return {?}
             */
            function () {
                return this._error;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._error = coerceBooleanProperty(value);
            },
            enumerable: true,
            configurable: true
        });
        return class_1;
    }(base));
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IsFocused() { }
if (false) {
    /** @type {?} */
    IsFocused.prototype.focused;
}
/**
 * @template T
 * @param {?} base
 * @return {?}
 */
function mixinFocused(base) {
    return /** @class */ (function (_super) {
        __extends(class_1, _super);
        function class_1() {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var _this = _super.apply(this, __spread(args)) || this;
            _this._focused = false;
            return _this;
        }
        Object.defineProperty(class_1.prototype, "focused", {
            get: /**
             * @return {?}
             */
            function () {
                return this._focused;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._focused = coerceBooleanProperty(value);
            },
            enumerable: true,
            configurable: true
        });
        return class_1;
    }(base));
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IsGrouped() { }
if (false) {
    /** @type {?} */
    IsGrouped.prototype.grouped;
}
/**
 * @template T
 * @param {?} base
 * @return {?}
 */
function mixinGrouped(base) {
    return /** @class */ (function (_super) {
        __extends(class_1, _super);
        function class_1() {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var _this = _super.apply(this, __spread(args)) || this;
            _this._grouped = false;
            return _this;
        }
        Object.defineProperty(class_1.prototype, "grouped", {
            get: /**
             * @return {?}
             */
            function () {
                return this._grouped;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._grouped = coerceBooleanProperty(value);
            },
            enumerable: true,
            configurable: true
        });
        return class_1;
    }(base));
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IsReadonly() { }
if (false) {
    /** @type {?} */
    IsReadonly.prototype.readonly;
}
/**
 * @template T
 * @param {?} base
 * @return {?}
 */
function mixinReadonly(base) {
    return /** @class */ (function (_super) {
        __extends(class_1, _super);
        function class_1() {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var _this = _super.apply(this, __spread(args)) || this;
            _this._readonly = false;
            return _this;
        }
        Object.defineProperty(class_1.prototype, "readonly", {
            get: /**
             * @return {?}
             */
            function () {
                return this._readonly;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._readonly = coerceBooleanProperty(value);
            },
            enumerable: true,
            configurable: true
        });
        return class_1;
    }(base));
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IsRequired() { }
if (false) {
    /** @type {?} */
    IsRequired.prototype.required;
}
/**
 * @template T
 * @param {?} base
 * @return {?}
 */
function mixinRequired(base) {
    return /** @class */ (function (_super) {
        __extends(class_1, _super);
        function class_1() {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var _this = _super.apply(this, __spread(args)) || this;
            _this._required = false;
            return _this;
        }
        Object.defineProperty(class_1.prototype, "required", {
            get: /**
             * @return {?}
             */
            function () {
                return this._required;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._required = coerceBooleanProperty(value);
            },
            enumerable: true,
            configurable: true
        });
        return class_1;
    }(base));
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var BbRegex = {
    email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/,
    fullNumber: /^\d*[1-9]\d*$/
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbValidator = /** @class */ (function () {
    function BbValidator() {
    }
    /**
     * @param {?} control
     * @return {?}
     */
    BbValidator.email = /**
     * @param {?} control
     * @return {?}
     */
    function (control) {
        return BbRegex.email.test(control.value)
            ? null
            : { email: { valid: false } };
    };
    /**
     * @param {?} control
     * @return {?}
     */
    BbValidator.fullNumber = /**
     * @param {?} control
     * @return {?}
     */
    function (control) {
        return BbRegex.fullNumber.test(control.value)
            ? null
            : { fullNumber: { valid: false } };
    };
    return BbValidator;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { BbRegex, BbValidator, ImageConverter, Languages, Platform, coerceBooleanProperty, mixinDisabled, mixinError, mixinFocused, mixinGrouped, mixinLoad, mixinReadonly, mixinRequired };
//# sourceMappingURL=bravobit-bb-foundation.js.map
